﻿enum EGameState { gsOverworld, gsCombat };

class CMainController;
class CScriptEngine;
class CGameState;
class COverworld;
class CCombat;
class CIsland;

class CGameController
{
public:
	CGameController(Obelisk::IObelisk* aObelisk, CMainController* aOwner);
	~CGameController();

	bool Update();
	void Render();

	void DrawRect(float aX0, float aY0, float aX1, float aY1, const Obelisk::CColour& aColour);

	CGameState* Game() { return mGame; }

	void Combat(CIsland* aIsland);
	void FinishCombat();

	void GameOver(Obelisk::CString aMessage, int aSize);
	void WIN();

	bool IsCursorShowing() { return mCursor; }
	bool IsEnterPressed();
	bool IsEscapePressed();

	void FirstInRange();
	void FirstRank();
	void FirstIslandWon();
	void LevelWon(int aLevel);

private:
	Obelisk::IObelisk* mObelisk;
	CMainController *mOwner;

	bool mCursor;

	CScriptEngine *mScriptEngine;

	CGameState *mGame;

	EGameState mState;
	COverworld *mOverworld;
	CCombat *mCombat;

	bool mGameOver;
	bool mWin;
	Obelisk::CString mGameOverMessage;
	int mGameOverSize;

	bool mFirstCombat;
};