﻿class CIsland;

class CGameState
{
public:
	CGameState(Obelisk::IObelisk* aObelisk, CGameController* aOwner);
	~CGameState();

	void Update();

	Obelisk::CCollection<CIsland> GetIslands() { return mIslands; }
	void WinIsland(CIsland* aIsland);

	int GetRank() { return mRank; }
	int GetNumYourIslands() { return mNumYourIslands; }
	int GetOil() { return mOil; }
	int GetHeliOil() { return mHeliOil; }
	int GetHeliOilMax();
	int GetRankOil() { return mRankOil; }
	int GetRankOilMax();

	float GetBoatX() { return mBoatX; }
	float GetBoatY() { return mBoatY; }
	int GetBoatDir() { return mBoatDir; }
	int GetBoatFuel() { return mBoatFuel; }
	void Refuel();
	void MoveBoat(float aX, float aY);

	void SetNumHelis(int aNumHelis) { mNumHelis = aNumHelis; }
	int GetNumHelis() { return mNumHelis; }

private:
	Obelisk::IObelisk* mObelisk;
	CGameController *mOwner;

	void GenerateMap();
	Obelisk::CCollection<CIsland> GenerateIslands();
	Obelisk::CCollection<CIsland> mIslands;

	int mRank;
	int mNumYourIslands;
	int mOil;
	int mOilDelta;
	int mOilDiff;
	int mHeliOil;
	int mRankOil;
	int mHighestLevel;

	float mBoatX;
	float mBoatY;
	int mBoatDir;
	int mBoatFuel;
	float mBoatStartX;
	float mBoatStartY;
	float mBoatDestX;
	float mBoatDestY;
	int mBoatMoveStep;
	int mBoatMoveMaxSteps;
	void GetBoatPos(float& aBoatX, float& aBoatY);

	int mNumHelis;

	bool mFirstIslandWon;
};